
set -u

new_login=$1
new_uid=$2
new_gid=$3
new_home=$4

NL=$'\n'
export PATH=/usr/local/sbin:/usr/local/bin:$PATH


uid_min=`grep -E -m 1 "^UID_MIN" /etc/login.defs | sed -e 's/^\S\+\s\+\([0-9]\+\).*/\1/'`
if [ -z "$uid_min" ]
then
	uid_min=1000
fi


declare -A memberof
for grp in $(id -nG "$new_login")
do
	memberof[$grp]=1
done
unset grp

