
return {
	'getPath': function(elem, count_children, classes)
	{
		if(count_children == undefined) count_children = true;
		if(classes == undefined) classes = true;
		var names = [];
		while(elem.parentNode)
		{
			if(elem.id)
			{
				names.unshift('#'+elem.id);
				break;
			}
			else
			{
				if(elem == elem.ownerDocument.documentElement)
					names.unshift(elem.tagName);
				else
				{
					name = elem.tagName;
					if(classes)
					{
						name = name + '.' + elem.classList.toString().replace(' ', '.');
					}
					if(count_children)
					{
						var c;
						for(c=1, e=elem; e.previousElementSibling; e=e.previousElementSibling, c++);
						name = name + ':nth-child(' + c + ')';
					}
					names.unshift(name);
				}
				elem = elem.parentNode;
			}
		}
		return names.join(" > ");
	},
};
