#!javascript
/*
	Save session on every navigation.
	Add 'session_save' command.
	Do not confuse with 'save_session' command that exits.
*/

function session_save()
{
	/* io.print("session_save..."); */
	io.sessionSave();
}

signals.connect('loadCommitted', function(webview)
{
	session_save();
});

signals.connect('closeTab', function(webview)
{
	session_save();
});

bind('', session_save, 'session_save');
