#!javascript

function textarea_backup()
{
	var elems = document.getElementsByTagName('TEXTAREA');
	for(var n=0; n<elems.length; n++)
	{
		elems[n].addEventListener('keyup', function(evt)
		{
			var backup = JSON.parse(localStorage.getItem("textarea_backup"));
			if(typeof(backup) != 'object' || backup == null) backup = {};
			
			var data = {
				id: this.id,
				name: this.name,
				value: this.value,
			};
			if(backup[location.origin] == undefined) backup[location.origin] = {};
			if(backup[location.origin][location.pathname] == undefined) backup[location.origin][location.pathname] = {};
			if(backup[location.origin][location.pathname].by_id == undefined) backup[location.origin][location.pathname].by_id = {};
			backup[location.origin][location.pathname].by_id[this.id] = data;
			if(backup[location.origin][location.pathname].by_name == undefined) backup[location.origin][location.pathname].by_name = {};
			backup[location.origin][location.pathname].by_name[this.name] = data;
			
			localStorage.setItem("textarea_backup", JSON.stringify(backup));
		});
		
		var backup = JSON.parse(localStorage.getItem("textarea_backup"));
		if(typeof(backup) != 'object' || backup == null) backup = {};
		
		if(backup[location.origin] != undefined && backup[location.origin][location.pathname] != undefined)
		{
			var val;
			if(backup[location.origin][location.pathname].by_id[elems[n].id] != undefined)
				val = backup[location.origin][location.pathname].by_id[elems[n].id].value;
			else if(backup[location.origin][location.pathname].by_name[elems[n].name] != undefined)
				val = backup[location.origin][location.pathname].by_name[elems[n].name].value;
			
			if(val)
			{
				if(elems[n].value == '')
					elems[n].value = val;
				else
				{
					var link = document.createElement('A');
					link.href = 'javascript:;';
					link.innerHTML = "restore textarea";
					link.setAttribute('data-textarea-id', elems[n].id);
					link.setAttribute('data-textarea-name', elems[n].name);
					link.setAttribute('data-textarea-value', val);
					link.addEventListener('click', function(e)
					{
						var id = this.getAttribute('data-textarea-id');
						var name = this.getAttribute('data-textarea-name');
						var val = this.getAttribute('data-textarea-value');
						if(id != undefined) document.getElementById(id).value = val;
						else if(name != undefined) document.getElementsByName(name)[0].value = val;
					});
					
					elems[n].parentNode.insertBefore(link, elems[n]);
				}
			}
		}
	}
}

signals.connect('loadFinished', function(webview, frame)
{
	if(webview.allFrames.length > 0)
	{
		webview.inject(util.getBody(textarea_backup), true);
	}
});
