#!javascript

function set_comments_per_page()
{
	var links = document.getElementsByTagName("A");
	for(var n = 0; n < links.length; n++)
	{
		var href = links[n].href;
		if(href != undefined && href.match(/\/(node|cikkek|szavazasok|comment)\//))
		{
			var fragpos = href.lastIndexOf("#");
			var cur_fragpos = document.location.href.lastIndexOf("#");
			if(fragpos == -1) fragpos = href.length;
			if(href.substr(0, fragpos) != document.location.href.substr(0, cur_fragpos) && !href.match(/comments_per_page=/))
			{
				var glue = (href.indexOf("?")==-1) ? "?" : "&";
				links[n].href = href.substr(0, fragpos) + glue + "comments_per_page=9999" + href.substr(fragpos, href.length - fragpos);
			}
		}
	}
}

function set_style()
{
	var css = document.createElement("STYLE");
	css.type = "text/css";
	css.innerHTML = "#all { font-size: 12pt; }";
	document.head.appendChild(css);
}

signals.connect('documentLoaded', function(webview, frame)
{
	if(webview.allFrames.length > 0)
	{
		if(webview.uri.match(/^http:\/\/hup\.hu\//))
		{
			webview.inject(util.getBody(set_comments_per_page), true);
			webview.inject(util.getBody(set_style), true);
		}
	}
});
