#!javascript

function yt_thumbs()
{
	const LOOP_INTERVAL = 1000; // 1000 = 1 second
	var loopHandler, img, imgs;

	function mo(evt)
	{
		if(evt.target.nodeName=='IMG' && evt.target.getAttribute('src') && evt.target.getAttribute('src').search(/default\.jpg(\?|$)/) > -1)
		{
			start(evt);
			evt.target.addEventListener('mouseout', end, false);		
		}
	}

	document.addEventListener('mouseover', mo, false);
	//GM_registerMenuCommand('Youtube Thumbs: toogle buttons', function(){GM_setValue('noButtons',!GM_getValue('noButtons'))});

	function start(evt)
	{
		img = evt.target;
		//imgZIndex(evt);
		img.setAttribute('data-original-src', img.getAttribute('src'));
		img.setAttribute('src', img.getAttribute('src').replace(/(hq)?default\.jpg(\?.*|$)/, '1.jpg'));
		loopHandler = setInterval(loop, LOOP_INTERVAL);
	}


	function loop()
	{
		var num = parseInt( img.getAttribute('src').match(/(\d)\.jpg/)[1] );
		if(num==3) 
			num = 1;
		else 
			num++;
		img.setAttribute('src', img.getAttribute('src').replace(/\d\.jpg/, ''+num+'.jpg'));
	}


	function end(evt)
	{
		var node;
		clearInterval(loopHandler);
		evt.target.setAttribute('src', img.getAttribute('data-original-src'));
		img.style.zIndex = null;
		img = null;
	}


	/*
	function imgZIndex(evt){
		if(GM_getValue('noButtons') || evt.ctrlKey){
			img.style.zIndex = '999999999';
		}else{
			img.style.zIndex = null;
		}	
	}
	*/
}

signals.connect('documentLoaded', function(webview, frame)
{
	if(webview.allFrames.length > 0)
	{
		if(webview.uri.match(/https?:\/\/www.youtube.com\//))
		{
			webview.inject(util.getBody(yt_thumbs), true);
		}
	}
});
